function LibZdNextListener(ScreenService, LibLoginService, LibUtilities, templateManager) {
    window.addEventListener('message', handleMessageEvent);

    function handleMessageEvent(event) {
        if(event.data.type === 'logoutByZdNext') {
            logoutByZdNext()
        } else if (event.data.type === 'versionInfo') {
            var versionInfo = event.data.data.versionInfo;
            if(versionInfo && templateManager.versionData && templateManager.versionData.dependencies) {
                templateManager.versionData.name = versionInfo.name;
                templateManager.versionData.version = versionInfo.version;
                templateManager.versionData.dependencies.backend = versionInfo.backend;
                templateManager.versionData.dependencies.frontend = versionInfo.frontend;
                templateManager.versionData.dependencies.modules = versionInfo.modules;
                templateManager.versionData.dependencies.changeCurrentVersion('frontend');
                templateManager.updateTemplate();
              }
        } else if (event.data.type === 'updateTranslationNext') {
            if(event.data.data.isError) {
                window.libTranslateDefer.reject(event.data.data.message);
            } else {
                window.libTranslateDefer.resolve();
            }
        }
    }

    var logoutByZdNext = function() {
        ScreenService.showLoader();
        LibLoginService.logout().then(function () {
            ScreenService.hideLoader();
            localStorage.removeItem('IS_LOGGED');
            localStorage.removeItem('LOGIN_USER');
            localStorage.removeItem('LOGIN_TOKEN');
            localStorage.removeItem('LOGIN_ERASE_HASH');
            LibUtilities.redirectToLogin();
        }).catch(function(error) {
            ScreenService.hideLoader();
            LibUtilities.showErrorMessage(error);
        });
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('LibZdNextListener', LibZdNextListener);
});
